/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, IEnumerable_$type, fromEnum, typeCast, Date_$type, Boolean_$type, Array_$type, runOn, Number_$type, String_$type, Delegate_$type, markType } from "./type";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { TypeDescriptionCleanups } from "./TypeDescriptionCleanups";
import { Dictionary$2 } from "./Dictionary$2";
import { Description } from "./Description";
import { DescriptionTreeNode } from "./DescriptionTreeNode";
import { Queue$1 } from "./Queue$1";
import { DescriptionTreeAction } from "./DescriptionTreeAction";
import { DescriptionRef } from "./DescriptionRef";
import { List$1 } from "./List$1";
import { TypeDescriptionPropretyTransforms } from "./TypeDescriptionPropretyTransforms";
import { DescriptionSerializerBuilder } from "./DescriptionSerializerBuilder";
import { DescriptionSerializer } from "./DescriptionSerializer";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { JsonDictionaryParser } from "./JsonDictionaryParser";
import { DescriptionTreeBuilder } from "./DescriptionTreeBuilder";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { JsonDictionaryValue } from "./JsonDictionaryValue";
import { JsonDictionaryArray } from "./JsonDictionaryArray";
import { TypeDescriptionMetadata } from "./TypeDescriptionMetadata";
import { DescriptionTreeReconciler } from "./DescriptionTreeReconciler";
import { HashSet$1 } from "./HashSet$1";
import { NotImplementedException } from "./NotImplementedException";
import { ComponentRendererAdapter } from "./ComponentRendererAdapter";
import { stringIsNullOrEmpty, stringStartsWith, stringEndsWith } from "./string";
/**
 * @hidden
 */
export let ComponentRenderer = /*@__PURE__*/ (() => {
    class ComponentRenderer extends Base {
        constructor() {
            super();
            this.d = null;
            this._context = null;
            this._isProceedOnErrorEnabled = false;
            this.f = null;
            this.g = null;
            this.ak = new Dictionary$2(Base.$, Description.$, 0);
            this.al = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.am = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.aj = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.ai = new Dictionary$2(Base.$, DescriptionTreeNode.$, 0);
            this.ap = new Dictionary$2(Base.$, ContainerState.$, 0);
            this.an = new Dictionary$2(Base.$, Queue$1.$.specialize(Queue$1.$.specialize(DescriptionTreeAction.$)), 0);
            this.ah = new Dictionary$2(Base.$, Boolean_$type, 0);
            this.ao = new Dictionary$2(String_$type, DescriptionRef.$, 0);
            this.aq = new Dictionary$2(String_$type, Base.$, 0);
            this.as = new Dictionary$2(String_$type, Base.$, 0);
            this.ar = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
            this.au = new List$1(Delegate_$type, 0);
            this.av = new List$1(Delegate_$type, 0);
            this._shouldNamespaceSystemRefValues = false;
            let a = this.e();
            this.d = a;
            this.context = new TypeDescriptionContext(a, ComponentRenderer.platform);
            this.f = new TypeDescriptionPropretyTransforms();
            this.g = new TypeDescriptionCleanups();
        }
        get context() {
            return this._context;
        }
        set context(a) {
            this._context = a;
        }
        get isProceedOnErrorEnabled() {
            return this._isProceedOnErrorEnabled;
        }
        set isProceedOnErrorEnabled(a) {
            this._isProceedOnErrorEnabled = a;
        }
        e() {
            return (new ComponentRendererAdapter());
        }
        toJson(a) {
            let b = new DescriptionSerializerBuilder();
            let c = new DescriptionSerializer();
            b.f("{");
            b.i();
            b.f("\"descriptions\": {");
            b.i();
            let d = true;
            for (let e of fromEnum(this.ai.keys)) {
                if (d) {
                    d = false;
                }
                else {
                    b.f(",");
                }
                let f = e;
                let g = this.ai.item(e);
                let h = "root";
                h = a(f);
                if (stringIsNullOrEmpty(h)) {
                    h = "root";
                }
                b.e("\"" + h + "\"");
                b.e(": ");
                c.q(this.context, g, b);
            }
            b.f("");
            b.h();
            b.e("}");
            if (this.as.count > 0) {
                b.e(",");
            }
            b.f("");
            if (this.as.count > 0) {
                d = true;
                b.f("refs: {");
                b.i();
                for (let i of fromEnum(this.as.keys)) {
                    if (!this.k(i, this.as.item(i))) {
                        continue;
                    }
                    if (d) {
                        d = false;
                    }
                    else {
                        b.f(",");
                    }
                    this.cs(b, i, this.as.item(i));
                }
                b.f("");
                b.h();
                b.f("}");
            }
            b.h();
            b.f("}");
            return b.toString();
        }
        cs(a, b, c) {
            a.e("\"" + b + "\": ");
            this.ct(a, c);
        }
        ct(a, b) {
            if (this.s(b)) {
                if (typeof b === 'string') {
                    a.e(b == null ? "null" : "\"" + b.toString() + "\"");
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeof b === 'number') {
                    a.e(b == null ? "null" : b.toString());
                }
                else if (typeCast(Date_$type, b) !== null) {
                    let v_ = b;
                    a.e("\"" + (v_.toJSON()) + "\"");
                }
                else if (typeCast(Boolean_$type, b) !== null) {
                    a.e(b == null ? "null" : b.toString().toLowerCase());
                }
                else {
                    a.e("null");
                }
            }
            else {
                if (b == null) {
                    a.e("null");
                    return;
                }
                if (this.q(b)) {
                    a.f("[");
                    a.i();
                    let c = new DataSourceLocalDataProvider();
                    c.dataSource = b;
                    for (let d = 0; d < c.actualCount; d++) {
                        if (d > 0) {
                            a.f(",");
                        }
                        this.cr(a, c, d);
                    }
                    a.f("");
                    a.h();
                    a.e("]");
                }
                else {
                    let e = [b];
                    let f = new DataSourceLocalDataProvider();
                    f.dataSource = e;
                    this.cr(a, f, 0);
                }
            }
        }
        s(a) {
            if (typeof a === 'string') {
                return true;
            }
            if (typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number' || typeof a === 'number') {
                return true;
            }
            if (typeCast(Date_$type, a) !== null) {
                return true;
            }
            if (typeCast(Boolean_$type, a) !== null) {
                return true;
            }
            return false;
        }
        q(a) {
            if (typeCast(Array_$type, a) !== null) {
                return true;
            }
            if (typeCast(IEnumerable_$type, a) !== null) {
                return true;
            }
            return false;
        }
        cr(a, b, c) {
            a.f("{");
            a.i();
            let d = b.actualSchema;
            for (let e = 0; e < d.propertyNames.length; e++) {
                if (e > 0) {
                    a.f(",");
                }
                let f = d.propertyNames[e];
                if (stringStartsWith(f, "[")) {
                    f = f.substr(1, f.length - 2);
                }
                a.e("\"" + f + "\"");
                a.e(": ");
                let g = b.getItemValue(b.getItemAtIndex(c), d.propertyNames[e]);
                switch (d.propertyTypes[e]) {
                    case 0:
                        a.e(g == null ? "null" : "\"" + g.toString() + "\"");
                        break;
                    case 2:
                        a.e(g == null ? "null" : "\"" + g.toString() + "\"");
                        break;
                    case 10:
                    case 6:
                    case 5:
                    case 1:
                    case 3:
                    case 4:
                    case 7:
                        a.e(g == null ? "null" : g.toString());
                        break;
                    case 8:
                        let v_ = g;
                        a.e("\"" + (v_.toJSON()) + "\"");
                        break;
                    case 11:
                        this.ct(a, g);
                        break;
                }
            }
            a.h();
            a.f("}");
        }
        k(a, b) {
            if (b == null) {
                return true;
            }
            let v_ = b;
            if ((typeof v_ === 'function')) {
                return false;
            }
            return true;
        }
        createObjectFromJson(a, b) {
            let c = new JsonDictionaryParser();
            let d = c.parse(a);
            let e = new DescriptionSerializer();
            let f = false;
            let g = e.d(this.context, d, f, false);
            if (g.result == null) {
                return null;
            }
            let h = DescriptionTreeBuilder.createTree(this.context, g.result);
            let i = this.ap.item(b);
            if (h.b("Type")) {
                let j = h.a("Type").b;
                return this.bf(j, h, b, i, true, -1);
            }
            else {
                return this.be(typeCast(JsonDictionaryObject.$, d));
            }
        }
        loadJson(a, b) {
            this.b8(a, b, null, false, false, false);
        }
        loadJsonOverlay(a, b, c) {
            this.b8(a, b, c, true, false, true);
        }
        loadJsonDelta(a, b, c) {
            this.b8(a, b, null, true, c, false);
        }
        b8(a, b, c, d, e, f) {
            let g = new JsonDictionaryParser();
            let h = g.parse(a);
            let i = new DescriptionSerializer();
            i.g = this.isProceedOnErrorEnabled;
            let j = null;
            if (typeCast(JsonDictionaryObject.$, h) !== null) {
                let k = h;
                if (k.f("descriptions")) {
                    let l = k.item("descriptions");
                    if (typeCast(JsonDictionaryObject.$, l) !== null) {
                        let m = l;
                        let n = m.d();
                        for (let o = 0; o < n.length; o++) {
                            let p = n[o];
                            let q = m.item(p);
                            let r = b(p);
                            if (r == null) {
                                continue;
                            }
                            j = r;
                            let s = false;
                            let t = null;
                            if (this.isProceedOnErrorEnabled) {
                                try {
                                    t = i.d(this.context, q, s, false);
                                }
                                catch (u) {
                                    return;
                                }
                            }
                            else {
                                t = i.d(this.context, q, s, false);
                            }
                            if (t.result == null) {
                                continue;
                            }
                            if (f) {
                                if (!this.at.containsKey(r)) {
                                    let v = null;
                                    if (this.isProceedOnErrorEnabled) {
                                        try {
                                            v = i.d(this.context, q, s, true);
                                        }
                                        catch (w) {
                                            return;
                                        }
                                    }
                                    else {
                                        v = i.d(this.context, q, s, true);
                                    }
                                    this.co(v.result, r, d, true, false);
                                    let x = c(p);
                                    let y = this.at.item(r);
                                    this.b4(this.ai.item(r), x, y, r);
                                }
                            }
                            this.co(t.result, r, d, e, false);
                        }
                    }
                }
                if (k.f("refs") && j != null) {
                    let z = k.item("refs");
                    if (typeCast(JsonDictionaryObject.$, z) !== null) {
                        let aa = z;
                        let ab = aa.d();
                        for (let ac = 0; ac < ab.length; ac++) {
                            let ad = ab[ac];
                            let ae = aa.item(ad);
                            if (typeCast(JsonDictionaryValue.$, ae) !== null) {
                                let af = ae;
                                this.provideRefValue(j, ad, af.value);
                            }
                            else if (typeCast(JsonDictionaryArray.$, ae) !== null) {
                                let ag = ae;
                                let ah = this.a(ag);
                                this.provideRefValue(j, ad, ah);
                            }
                            else {
                                let ai = this.be(ae);
                                this.provideRefValue(j, ad, ai);
                            }
                        }
                    }
                }
            }
        }
        bq(a, b, c) {
            let d = a;
            if (c != null) {
                d = c.g(b);
            }
            else {
                if (TypeDescriptionMetadata.shouldCamelize(b)) {
                    d = TypeDescriptionMetadata.camelize(d);
                }
            }
            if (stringEndsWith(d, "Ref")) {
                d = d.substr(0, d.length - ("Ref").length);
            }
            return d;
        }
        b4(a, b, c, d) {
            if (!c.b(b)) {
                c.k(d, this.ai.item(d).f, b, this.ai.item(d), runOn(this, this.ce), -1);
            }
            for (let e of fromEnum(a.e())) {
                this.b5(this.bq(e.c, ComponentRenderer.platform, e.a), e.b, b, c, d, a.f);
            }
        }
        b5(a, b, c, d, e, f) {
            if (typeCast(DescriptionTreeNode.$, b) !== null) {
                let g = b;
                let h = this.d.getPropertyValue(c, a);
                if (!d.b(h) && !d.a(g.f)) {
                    d.k(e, g.f, h, g, runOn(this, this.ce), f);
                }
                for (let i of fromEnum(g.e())) {
                    this.b5(a + "." + this.bq(i.c, ComponentRenderer.platform, i.a), i.b, c, d, e, g.f);
                }
            }
            if (typeCast(Array_$type, b) !== null) {
                let j = new Dictionary$2(Number_$type, DescriptionTreeNode.$, 0);
                let k = 0;
                let l = b.length;
                let o = b;
                for (let n = 0; n < o.length; n++) {
                    let m = o[n];
                    if (typeCast(DescriptionTreeNode.$, m) !== null) {
                        let p = m;
                        j.item(k, p);
                    }
                    k++;
                }
                let q = this.d.getPropertyValue(c, a);
                k = 0;
                this.d.forPropertyValueItem(c, a, (r) => {
                    if (j.containsKey(k)) {
                        let s = j.item(k);
                        if (!d.b(r) && !d.a(s.f)) {
                            d.k(e, s.f, r, s, runOn(this, this.ce), f);
                        }
                        for (let t of fromEnum(s.e())) {
                            this.b5(a + "." + t.c, t.b, c, d, e, s.f);
                        }
                    }
                    k++;
                });
                if (l > 0 && k == 0) {
                    let r = this.bt(a);
                    this.d.forPropertyValueItem(c, r, (s) => {
                        if (j.containsKey(k)) {
                            let t = j.item(k);
                            if (!d.b(s) && !d.a(t.f)) {
                                d.k(e, t.f, s, t, runOn(this, this.ce), f);
                            }
                            for (let u of fromEnum(t.e())) {
                                this.b5(r + "." + u.c, u.b, c, d, e, t.f);
                            }
                        }
                        k++;
                    });
                }
            }
        }
        bt(a) {
            let b = a.lastIndexOf('.');
            let c = null;
            let d = a;
            if (b > 0) {
                c = a.substr(0, b);
                d = a.substr(b + 1);
            }
            d = "actual" + this.br(d);
            if (c != null) {
                return c + "." + d;
            }
            return d;
        }
        br(a) {
            return a.substr(0, 1).toUpperCase() + a.substr(1);
        }
        a(a) {
            let b = new Array(a.items.length);
            for (let c = 0; c < a.items.length; c++) {
                let d = this.be(a.items[c]);
                b[c] = d;
            }
            return b;
        }
        be(a) {
            if (a == null) {
                return null;
            }
            let b = {};
            let dict_ = b;
            let c = a.d();
            for (let d = 0; d < c.length; d++) {
                let key_ = c[d];
                if (typeCast(JsonDictionaryObject.$, a.item(key_)) !== null) {
                    let val_ = this.be(a.item(key_));
                    dict_[key_] = val_;
                }
                else if (typeCast(JsonDictionaryArray.$, a.item(key_)) !== null) {
                    let val_ = this.a(a.item(key_));
                    dict_[key_] = val_;
                }
                else {
                    let val_ = a.item(key_).value;
                    dict_[key_] = val_;
                }
            }
            return dict_;
        }
        get at() {
            return this.ap;
        }
        cleanup(a, b) {
            this.co(null, a, false, false, b);
        }
        render(a, b) {
            this.co(a, b, false, false, false);
        }
        co(a, b, c, d, e) {
            if (!this.ap.containsKey(b)) {
                this.ap.item(b, new ContainerState());
                this.ap.item(b).i = b;
            }
            this.ak.item(b, a);
            this.al.item(b, c);
            this.am.item(b, d);
            this.aj.item(b, e);
            this.ca(b, () => this.cm(b));
        }
        ca(a, b) {
            this.d.onUIThread(a, b);
        }
        cm(a) {
            if (this.ak.containsKey(a)) {
                let b = this.al.containsKey(a) ? this.al.item(a) : false;
                let c = this.am.containsKey(a) ? this.am.item(a) : false;
                let d = this.ak.item(a);
                this.ak.removeItem(a);
                let e = DescriptionTreeBuilder.createTree(this.context, d);
                let f = null;
                if (this.ai.containsKey(a)) {
                    f = this.ai.item(a);
                }
                let g = DescriptionTreeReconciler.c(f, e, b);
                if (c) {
                    let h = DescriptionTreeReconciler.a(f, g);
                    if (!this.ap.containsKey(a)) {
                        this.ap.addItem(a, ((() => {
                            let $ret = new ContainerState();
                            $ret.i = a;
                            return $ret;
                        })()));
                    }
                    let i = this.ap.item(a);
                    if (h.a.count > 0) {
                        for (let j of fromEnum(h.a)) {
                            if (i.a(j)) {
                                let k = i.j(j);
                                this.b2(a, k, i);
                            }
                        }
                    }
                    if (h.c.count > 0) {
                        for (let l of fromEnum(h.c)) {
                            let m = this.bk(a, i, l);
                            let n = this.d.getPropertyValue(m, l.i);
                            if (n != null) {
                                if (!i.b(n)) {
                                    let o = l.f;
                                    if (typeCast(DescriptionTreeNode.$, o) !== null) {
                                        let p = o.f;
                                        i.k(a, p, n, o, runOn(this, this.ce), l.b.f);
                                    }
                                }
                            }
                        }
                    }
                    if (h.d.count > 0) {
                        for (let q of fromEnum(h.d)) {
                            let r = q.f;
                            if (r != null) {
                                if (!i.b(r)) {
                                    let s = q.f;
                                    if (typeCast(DescriptionTreeNode.$, s) !== null) {
                                        let t = s.f;
                                        this.ai.item(a, s);
                                    }
                                }
                            }
                        }
                    }
                    if (h.b.count > 0) {
                        for (let u of fromEnum(h.b)) {
                            let v = u.b.a(u.i).b;
                            if (v == null) {
                                continue;
                            }
                            let w = new Dictionary$2(String_$type, DescriptionTreeNode.$, 0);
                            for (let x = 0; x < v.length; x++) {
                                let y = v[x];
                                if (typeCast(DescriptionTreeNode.$, y) !== null) {
                                    let z = y;
                                    if (z.b("Name")) {
                                        w.item(z.a("Name").b, z);
                                    }
                                }
                            }
                            if (w.count == 0) {
                                continue;
                            }
                            let aa = this.bk(a, i, u);
                            let ab = this.d.getPropertyValue(aa, u.i);
                            if (ab != null) {
                                let ac = 0;
                                this.d.forPropertyValueItem(aa, u.i, (ad) => {
                                    if (w.containsKey(this.d.getPropertyValue(ad, "Name").toString())) {
                                        if (!i.b(ad)) {
                                            let ae = w.item(this.d.getPropertyValue(ad, "Name").toString());
                                            if (typeCast(DescriptionTreeNode.$, ae) !== null) {
                                                let af = ae.f;
                                                i.k(a, af, ad, ae, runOn(this, this.ce), u.b.f);
                                            }
                                        }
                                    }
                                    ac++;
                                });
                            }
                        }
                    }
                }
                else {
                    this.ai.item(a, e);
                }
                if (!c) {
                    this.cn(a, g);
                }
                if (this.aj.item(a)) {
                    this.ck(a);
                    if (this.ap.containsKey(a)) {
                        this.ap.removeItem(a);
                    }
                }
            }
        }
        provideRefValue(a, b, c) {
            this.ca(a, () => {
                if (!this.ap.containsKey(a)) {
                    this.ap.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let d = this.ap.item(a);
                this.ce(a, b, c, true);
            });
        }
        removeRefValue(a, b) {
            this.ca(a, () => {
                if (!this.ap.containsKey(a)) {
                    this.ap.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let c = this.ap.item(a);
                this.removeRefValueCore(a, b, true);
            });
        }
        ck(a) {
            let b = this.ap.item(a);
            let c = new List$1(String_$type, 0);
            for (let d of fromEnum(this.ao.keys)) {
                if (this.ao.item(d).c == 0) {
                    c.add(d);
                }
            }
            for (let e = 0; e < c.count; e++) {
                let f = this.shouldNamespaceSystemRefValues;
                this.shouldNamespaceSystemRefValues = false;
                this.removeRefValueCore(a, c._inner[e], this.as.containsKey(c._inner[e]));
                this.shouldNamespaceSystemRefValues = f;
            }
        }
        clearRefValues(a) {
            this.ca(a, () => {
                if (!this.ap.containsKey(a)) {
                    this.ap.addItem(a, ((() => {
                        let $ret = new ContainerState();
                        $ret.i = a;
                        return $ret;
                    })()));
                }
                let b = this.ap.item(a);
                this.clearUserRefValues();
            });
        }
        cn(a, b) {
            let c = this.ap.item(a);
            this.cb(a, c, b);
        }
        cq(a, b) {
            if (this.isProceedOnErrorEnabled) {
                try {
                    this.b3(a, b, true);
                }
                catch (c) {
                    this.ah.item(a, false);
                }
            }
            else {
                this.b3(a, b, true);
            }
        }
        cw(a, b) {
            if (this.isProceedOnErrorEnabled) {
                try {
                    this.b3(a, b, false);
                }
                catch (c) {
                    this.ah.item(a, false);
                }
            }
            else {
                this.b3(a, b, false);
            }
        }
        b3(a, b, c) {
            if (!c) {
                if (this.ah.containsKey(a) && this.ah.item(a)) {
                    return;
                }
            }
            this.ah.item(a, true);
            let d = true;
            while (d && this.an.item(a).count > 0) {
                while (this.an.item(a).count > 0 && this.an.item(a).c().count < 1) {
                    this.an.item(a).b();
                }
                if (this.an.item(a).count < 1) {
                    break;
                }
                let e = this.an.item(a).c();
                while (e.count > 0) {
                    let f = e.b();
                    d = this.u(a, b, f);
                    if (!d) {
                        break;
                    }
                }
            }
            if (d) {
                this.ah.item(a, false);
            }
        }
        cb(a, b, c) {
            let d = new Queue$1(DescriptionTreeAction.$);
            for (let e = 0; e < c.count; e++) {
                d.g(c._inner[e]);
            }
            if (!this.an.containsKey(a)) {
                this.an.addItem(a, new Queue$1(Queue$1.$.specialize(DescriptionTreeAction.$)));
            }
            this.an.item(a).g(d);
            this.cw(a, b);
        }
        cc(a, b, c) {
            for (let d = 0; d < c.count; d++) {
                this.u(a, b, c._inner[d]);
            }
        }
        u(a, b, c) {
            switch (c.a) {
                case 5: return this.v(a, b, c);
                case 2: return this.w(a, b, c);
                case 4: return this.x(a, b, c);
                case 3: return this.y(a, b, c);
                case 1: return this.z(a, b, c);
                case 0: return this.aa(a, b, c);
            }
            return true;
        }
        aa(a, b, c) {
            let d = this.bk(a, b, c);
            this.ag(a, b, c, d);
            return true;
        }
        ag(a, b, c, d) {
            let e = this.bh(c, a, b);
            e = this.f.transform(ComponentRenderer.platform, e, c);
            if (c.c != null && c.c.knownType == 9) {
                this.ae(a, b, c.h(ComponentRenderer.platform), c.c, e, d);
            }
            else {
                this.cu(a, b, c.h(ComponentRenderer.platform), c.c, e, c.g, d);
            }
            return true;
        }
        ae(a, b, c, d, e, f) {
            if (this.ar.containsKey(c)) {
                for (let g of fromEnum(this.ar.item(c))) {
                    g(c, f, e);
                }
            }
            this.d.setOrUpdateCollectionOnTarget(a, c, d, this.context, f, e);
            return true;
        }
        bh(a, b, c) {
            if (a.c == null) {
                return a.f;
            }
            switch (a.c.knownType) {
                case 10: return this.ay(a, b, c);
                case 7: return this.az(a);
                case 4: return this.a0(a);
                case 6: return this.a1(a);
                case 9: return this.ay(a, b, c);
                case 5: return this.a2(a);
                case 16: return this.a3(a);
                case 20: return this.bl(a, c);
                case 15: return null;
                case 3: return this.a4(a);
                case 19: return this.bm(a, c);
                case 8: return this.a6(a, b, c);
                case 13: return null;
                case 18: return this.bn(a, c);
                case 1: return this.a7(a);
                case 11: return this.a8(a);
                case 14: return this.a9(a);
                case 12: return this.ba(a);
                case 2: return this.bb(a);
                case 21: return this.bc(a);
                case 17: return this.bd(a, b, c);
                case 0: return null;
            }
            return null;
        }
        bd(a, b, c) {
            if (typeCast(DescriptionTreeNode.$, a.f) !== null) {
                let d = a.f;
                if (d.h == "EmbeddedRef") {
                    return this.bf(d.h, a.f, b, c, false, a.b.f);
                }
            }
            return a.f;
        }
        bc(a) {
            return a.f;
        }
        bb(a) {
            return a.f != null ? a.f.toString() : null;
        }
        ba(a) {
            let b = a.f;
            let width_ = b.width;
            let height_ = b.height;
            let c = { width: width_, height: height_ };
            return c;
        }
        a9(a) {
            let b = a.f;
            let top_ = b.top;
            let left_ = b.left;
            let width_ = b.width;
            let height_ = b.height;
            let c = { left: left_, top: top_, width: width_, height: height_ };
            return c;
        }
        a8(a) {
            let b = a.f;
            let x_ = b.x;
            let y_ = b.y;
            let c = { x: x_, y: y_ };
            return c;
        }
        a7(a) {
            if (a.f == null) {
                if (a.c != null && (a.c.specificType == "double" || a.c.specificType == "float")) {
                    return NaN;
                }
                return 0;
            }
            return a.f;
        }
        b(a, b) {
            if (this.ao.containsKey(a)) {
                let c = this.ao.item(a);
                return c;
            }
            let d = new DescriptionRef(a);
            this.ao.addItem(a, d);
            return d;
        }
        bn(a, b) {
            return a.f == null ? null : this.b(a.f, b);
        }
        a6(a, b, c) {
            let d = a.c.specificType;
            if (d == null) {
                d = a.c.specificExternalType;
            }
            if (typeCast(DescriptionTreeNode.$, a.f) !== null) {
                let e = a.f;
                if (e.b("Type")) {
                    d = e.a("Type").b;
                }
            }
            let f = this.bf(d, a.f, b, c, false, a.b.f);
            return f;
        }
        bm(a, b) {
            return a.f == null ? null : this.b(a.f, b);
        }
        a4(a) {
            return a.f;
        }
        bl(a, b) {
            return a.f == null ? null : this.b(a.f, b);
        }
        bp(a) {
            return a;
        }
        a3(a) {
            let b = a.f;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = this.bp(b[d]);
            }
            return c;
        }
        a2(a) {
            return this.bp(a.f);
        }
        a1(a) {
            let b = a.f;
            if (b == null) {
                return null;
            }
            let c = new Array(b.length);
            for (let d = 0; d < b.length; d++) {
                c[d] = this.bo(b[d]);
            }
            return c;
        }
        bo(a) {
            return a;
        }
        a0(a) {
            return this.bo(a.f);
        }
        az(a) {
            return a.f;
        }
        addPropertyUpdatingListener(a, b) {
            if (!this.ar.containsKey(a)) {
                this.ar.addItem(a, new List$1(Delegate_$type, 0));
            }
            this.ar.item(a).add(b);
        }
        addReferenceLookupListener(a) {
            this.au.add(a);
        }
        removePropertyUpdatingListener(a, b) {
            if (this.ar.containsKey(a)) {
                this.ar.item(a).remove(b);
                if (this.ar.item(a).count == 0) {
                    this.ar.removeItem(a);
                }
            }
        }
        addNamespaceLookupListener(a) {
            this.av.add(a);
        }
        removeNamespaceLookupListener(a) {
            this.av.remove(a);
        }
        ay(a, b, c) {
            if (a.f == null) {
                return null;
            }
            let d = a.f;
            let e = new List$1(Base.$, 0);
            let f = a.c.specificType;
            if (f == null) {
                f = a.c.specificExternalType;
            }
            if (a.c.knownType == 9) {
                f = a.c.collectionElementType;
                if (f == null) {
                    f = a.c.specificExternalType;
                }
            }
            for (let g = 0; g < d.length; g++) {
                let h = f;
                if (typeCast(DescriptionTreeNode.$, d[g]) !== null) {
                    let i = d[g];
                    if (i.b("Type")) {
                        h = i.a("Type").b;
                    }
                }
                let j = this.bf(h, d[g], b, c, false, a.b.f);
                e.add1(j);
            }
            return e.toArray();
        }
        cu(a, b, c, d, e, f, g) {
            if (typeCast(DescriptionRef.$, e) !== null) {
                let h = e;
                let i = false;
                if (f != null && typeof f === 'string') {
                    if (this.n(f)) {
                        let j = this.c(f);
                        if (Base.equalsStatic(j, e)) {
                            i = true;
                        }
                        else {
                            j.j(a, g, c);
                        }
                    }
                }
                if (this.o(e)) {
                    let k = e;
                    if (k.e != null && k.e.length > 0 && this.aq.containsKey(k.e)) {
                        k.a = true;
                    }
                    e = this.bj(e);
                    this.cv(g, c, d, e, f, k);
                }
                else {
                    this.d.onPendingRef(g, c, d, e);
                }
                let l = null;
                l = (m, n) => {
                    let o = m;
                    if (o.e != null && o.e.length > 0 && this.aq.containsKey(o.e)) {
                        o.a = true;
                    }
                    let p = this.bj(m);
                    this.cv(g, c, d, p, f, o);
                };
                if (!i) {
                    h.g(a, g, c, l);
                }
                return;
            }
            this.cv(g, c, d, e, f, null);
        }
        hasUserRef(a) {
            return this.as.containsKey(a);
        }
        get shouldNamespaceSystemRefValues() {
            return this._shouldNamespaceSystemRefValues;
        }
        set shouldNamespaceSystemRefValues(a) {
            this._shouldNamespaceSystemRefValues = a;
        }
        ce(a, b, c, d) {
            let e = null;
            if (d) {
                if (this.as.containsKey(b)) {
                    e = this.as.item(b);
                }
                this.as.item(b, c);
            }
            else {
                if (this.shouldNamespaceSystemRefValues) {
                    let f = "";
                    if (this.av != null && this.av.count > 0) {
                        for (let g = 0; g < this.av.count; g++) {
                            f = this.av._inner[g](a);
                        }
                    }
                    if (!stringIsNullOrEmpty(f)) {
                        b = f + "/" + b;
                    }
                }
                if (this.aq.containsKey(b)) {
                    e = this.aq.item(b);
                }
                this.aq.item(b, c);
                if (this.ao.containsKey(b)) {
                    this.ao.item(b).a = true;
                }
            }
            if (this.ao.containsKey(b)) {
                this.ao.item(b).f(e, c);
            }
        }
        removeRefValueCore(a, b, c) {
            let d = null;
            if (c) {
                if (this.as.containsKey(b)) {
                    d = this.as.item(b);
                }
                this.as.removeItem(b);
            }
            else {
                if (this.shouldNamespaceSystemRefValues) {
                    let e = "";
                    if (this.av != null && this.av.count > 0) {
                        for (let f = 0; f < this.av.count; f++) {
                            e = this.av._inner[f](a);
                        }
                    }
                    if (!stringIsNullOrEmpty(e)) {
                        b = e + "/" + b;
                    }
                }
                if (this.aq.containsKey(b)) {
                    d = this.aq.item(b);
                }
                this.aq.removeItem(b);
            }
            if (this.ao.containsKey(b)) {
                this.ao.item(b).f(d, this.bj(this.ao.item(b)));
                if (this.ao.item(b).c <= 0) {
                    this.ao.item(b).h();
                    this.ao.removeItem(b);
                }
            }
        }
        clearUserRefValues() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.as.keys)) {
                a.add(b);
            }
            for (let c of fromEnum(a)) {
                this.removeRefValueCore(null, c, true);
            }
        }
        o(a) {
            return this.as.containsKey(a.e) || this.aq.containsKey(a.e);
        }
        bj(a) {
            if (this.as.containsKey(a.e)) {
                return this.as.item(a.e);
            }
            if (this.aq.containsKey(a.e)) {
                return this.aq.item(a.e);
            }
            return null;
        }
        n(a) {
            return this.ao.containsKey(a);
        }
        c(a) {
            return this.ao.item(a);
        }
        bk(a, b, c) {
            return b.j(c.b.f);
        }
        z(a, b, c) {
            let d = this.bk(a, b, c);
            this.ad(a, b, c, d);
            return true;
        }
        ad(a, b, c, d) {
            this.d.resetPropertyOnTarget(a, c.h(ComponentRenderer.platform), c.c, d);
            return true;
        }
        y(a, b, c) {
            if (c.b == null) {
                return this.ac(a, b, c);
            }
            else {
                let d = this.bk(a, b, c);
                this.cp(a, b, c, d);
            }
            return true;
        }
        cp(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            let f = this.bf(c.c.collectionElementType, c.f, a, b, false, c.b.f);
            this.d.replaceItemInCollection(e, c.c, d, c.d, f);
            if (c.g != null && typeCast(DescriptionTreeNode.$, c.g) !== null) {
                let g = c.g.f;
                if (g >= 0) {
                    let h = b.j(g);
                    if (h != null) {
                        this.b2(a, h, b);
                    }
                }
            }
        }
        ac(a, b, c) {
            let d = this.d.getRootObject(a);
            if (d != null) {
                this.b2(a, d, b);
            }
            if (!(typeCast(DescriptionTreeNode.$, c.f) !== null)) {
                throw new NotImplementedException(0);
            }
            let e = c.f;
            let f = false;
            this.d.replaceRootItem(a, e.h, this.context, (g) => {
                let h = this.d.getRootObject(a);
                b.k(a, e.f, h, e, runOn(this, this.ce), -1);
                let i = this.aw(e);
                this.cc(a, b, i);
                f = true;
                if (g) {
                    this.cq(a, b);
                }
            });
            return f;
        }
        b2(a, b, c) {
            let d = this.ax(a, b, c);
            for (let e of fromEnum(this.ao.values)) {
                e.i(b);
            }
            if (d != -1) {
                c.l(this, a, d, runOn(this, this.removeRefValueCore));
            }
            this.g.b(ComponentRenderer.platform, b);
        }
        ax(a, b, c) {
            return c.h(b);
        }
        x(a, b, c) {
            if (c.b == null) {
                return this.ab(a, b, c);
            }
            else {
                let d = this.bk(a, b, c);
                this.cf(a, b, c, d);
            }
            return true;
        }
        cf(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            this.d.removeItemFromCollection(e, c.c, d, c.e);
            if (c.g != null && typeCast(DescriptionTreeNode.$, c.g) !== null) {
                let f = c.g.f;
                if (f >= 0) {
                    let g = b.j(f);
                    if (g != null) {
                        this.b2(a, g, b);
                    }
                }
            }
        }
        ab(a, b, c) {
            let d = this.d.getRootObject(a);
            if (d != null) {
                this.b2(a, d, b);
            }
            let e = false;
            this.d.removeRootItem(a, this.context, (f) => {
                e = true;
                if (f) {
                    this.cq(a, b);
                }
            });
            return e;
        }
        w(a, b, c) {
            if (c.b == null) {
                return this.j(a, b, c);
            }
            else {
                let d = this.bk(a, b, c);
                this.bu(a, b, c, d);
            }
            return true;
        }
        j(a, b, c) {
            if (!(typeCast(DescriptionTreeNode.$, c.f) !== null)) {
                throw new NotImplementedException(0);
            }
            let d = c.f;
            let e = false;
            this.d.replaceRootItem(a, d.h, this.context, (f) => {
                let g = this.d.getRootObject(a);
                b.k(a, d.f, g, d, runOn(this, this.ce), -1);
                let h = this.aw(d);
                this.cc(a, b, h);
                e = true;
                if (f) {
                    this.cq(a, b);
                }
            });
            return e;
        }
        bu(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            let f = c.c.collectionElementType;
            if (typeCast(DescriptionTreeNode.$, c.f) !== null) {
                let g = c.f;
                if (g.b("Type")) {
                    f = g.a("Type").b;
                }
            }
            let h = this.bf(f, c.f, a, b, false, c.b.f);
            this.d.addItemToCollection(e, c.c, d, c.d, h);
        }
        bf(a, b, c, d, e, f) {
            if (this.r(a)) {
                return b;
            }
            let g = null;
            if (b != null && typeCast(DescriptionTreeNode.$, b) !== null) {
                let h = b;
                if (h.b("Name")) {
                    let i = h.a("Name").b;
                    if (!stringIsNullOrEmpty(i)) {
                        if (this.shouldNamespaceSystemRefValues) {
                            let j = "";
                            if (this.av != null && this.av.count > 0) {
                                for (let k = 0; k < this.av.count; k++) {
                                    j = this.av._inner[k](c);
                                }
                            }
                            if (!stringIsNullOrEmpty(j)) {
                                i = j + "/" + i;
                            }
                        }
                        if (this.aq.containsKey(i)) {
                            let l = this.aq.item(i);
                            g = l;
                        }
                    }
                }
                if (g == null) {
                    g = this.context.l(a, c);
                }
            }
            else {
                g = this.context.l(a, c);
            }
            if (b == null) {
                return g;
            }
            if (typeCast(DescriptionTreeNode.$, b) !== null) {
                let m = b;
                if (m.h == "EmbeddedRef") {
                    let n = "uuid";
                    let o = null;
                    for (let p = 0; p < m.e().count; p++) {
                        if (m.e()._inner[p].c == "RefType") {
                            n = m.e()._inner[p].b;
                        }
                        if (m.e()._inner[p].c == "Value") {
                            o = m.e()._inner[p].b;
                        }
                    }
                    if (o != null) {
                        for (let q = 0; q < this.au.count; q++) {
                            let r = this.au._inner[q](c, n, o);
                            if (r != null) {
                                return r;
                            }
                        }
                        return null;
                    }
                }
                else {
                    d.k(c, m.f, g, m, runOn(this, this.ce), f);
                    let s = this.aw(m);
                    this.cc(c, d, s);
                    if (e) {
                        d.l(this, c, m.f, runOn(this, this.removeRefValueCore));
                    }
                }
            }
            if (typeof b === 'string' && a.toLowerCase() != "string") {
                return this.a5(a, b);
            }
            if (a == "object" || a == "Object") {
                return b;
            }
            return g;
        }
        r(a) {
            return a == "int" || a == "Int32" || a == "short" || a == "Int16" || a == "double" || a == "Double" || a == "float" || a == "Float" || a == "Single" || a == "single" || a == "DateTime" || a == "decimal" || a == "Decimal" || a == "long" || a == "Int64" || a == "byte" || a == "bool" || a == "string" || a == "String";
        }
        a5(a, b) {
            return this.context.h(a, b);
        }
        aw(a) {
            let b = a.e();
            let c = new List$1(DescriptionTreeAction.$, 0);
            for (let d = 0; d < b.count; d++) {
                let e = new DescriptionTreeAction();
                e.a = 0;
                e.i = b._inner[d].c;
                e.c = b._inner[d].a;
                e.b = a;
                e.f = b._inner[d].b;
                c.add(e);
            }
            return c;
        }
        v(a, b, c) {
            if (c.b == null) {
                return this.m(a, b, c);
            }
            else {
                let d = this.bk(a, b, c);
                this.bz(a, b, c, d);
            }
            return true;
        }
        bz(a, b, c, d) {
            let e = c.h(ComponentRenderer.platform);
            this.d.clearCollection(d, e, c.c);
            if (c.g != null && typeCast(Array_$type, c.g) !== null) {
                let f = c.g;
                for (let g = 0; g < f.length; g++) {
                    let h = f[g];
                    if (h != null && typeCast(DescriptionTreeNode.$, h) !== null) {
                        let i = h.f;
                        if (i >= 0) {
                            let j = b.j(i);
                            if (j != null) {
                                this.b2(a, j, b);
                            }
                        }
                    }
                }
            }
        }
        cv(a, b, c, d, e, f) {
            if (this.ar.containsKey(b)) {
                for (let g of fromEnum(this.ar.item(b))) {
                    g(b, a, d);
                }
            }
            this.d.setPropertyValue(a, b, c, d, e, f);
        }
        bi(a, b) {
            return this.d.getPropertyValue(a, b);
        }
        m(a, b, c) {
            return this.l(a, b);
        }
        l(a, b) {
            let c = this.d.getRootObject(a);
            if (c != null) {
                this.b2(a, c, b);
            }
            let d = false;
            this.d.clearContainer(a, this.context, (e) => {
                d = true;
                if (e) {
                    this.cq(a, b);
                }
            });
            return d;
        }
    }
    ComponentRenderer.$t = /*@__PURE__*/ markType(ComponentRenderer, 'ComponentRenderer');
    ComponentRenderer.platform = 3;
    return ComponentRenderer;
})();
/**
 * @hidden
 */
export let ContainerState = /*@__PURE__*/ (() => {
    class ContainerState extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.e = new Dictionary$2(Number_$type, Base.$, 0);
            this.f = new Dictionary$2(Base.$, Number_$type, 0);
            this.d = new Dictionary$2(Number_$type, String_$type, 0);
            this.g = new Dictionary$2(Number_$type, HashSet$1.$.specialize(Number_$type), 0);
            this.c = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
        }
        k(a, b, c, d, e, f) {
            if (d.b("Name")) {
                this.d.item(b, d.a("Name").b);
                e(a, this.d.item(b), c, false);
            }
            this.e.item(b, c);
            this.f.item(c, b);
            if (!this.g.containsKey(b)) {
                this.g.item(b, new HashSet$1(Number_$type, 0));
            }
            this.g.item(b).add_1(f);
            if (f >= 0) {
                if (!this.c.containsKey(f)) {
                    this.c.item(f, new List$1(Number_$type, 0));
                }
                this.c.item(f).add(b);
            }
        }
        a(a) {
            return this.e.containsKey(a);
        }
        b(a) {
            return this.f.containsKey(a);
        }
        j(a) {
            return this.e.item(a);
        }
        l(a, b, c, d) {
            if (this.c.containsKey(c)) {
                let e = this.c.item(c);
                for (let f = 0; f < e.count; f++) {
                    if (!this.g.containsKey(e._inner[f]) || this.g.item(e._inner[f]).count < 1 || (this.g.item(e._inner[f]).count == 1 && this.g.item(e._inner[f]).contains(c))) {
                        if (this.e.containsKey(e._inner[f])) {
                            a.b2(b, this.e.item(e._inner[f]), this);
                        }
                    }
                }
                this.c.removeItem(c);
            }
            let g = this.e.item(c);
            this.f.removeItem(g);
            this.e.removeItem(c);
            if (this.g.containsKey(c)) {
                this.g.removeItem(c);
            }
            if (this.d.containsKey(c)) {
                let h = this.d.item(c);
                this.d.removeItem(c);
                d(b, h, false);
            }
        }
        h(a) {
            if (this.f.containsKey(a)) {
                return this.f.item(a);
            }
            return -1;
        }
    }
    ContainerState.$t = /*@__PURE__*/ markType(ContainerState, 'ContainerState');
    return ContainerState;
})();
//# sourceMappingURL=ComponentRenderer_combined.js.map
