/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, NotSupportedException, typeCast, typeGetValue, markType } from "./type";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { DescriptionTreeNode } from "./DescriptionTreeNode";
import { DescriptionSerializerBuilder } from "./DescriptionSerializerBuilder";
import { DescriptionTreeBuilder } from "./DescriptionTreeBuilder";
import { DescriptionResult } from "./DescriptionResult";
import { JsonDictionaryParser } from "./JsonDictionaryParser";
import { JsonDictionaryObject } from "./JsonDictionaryObject";
import { EmbeddedRefDescription } from "./EmbeddedRefDescription";
import { JsonDictionaryArray } from "./JsonDictionaryArray";
import { PointDescription } from "./PointDescription";
import { SizeDescription } from "./SizeDescription";
import { RectDescription } from "./RectDescription";
import { NotImplementedException } from "./NotImplementedException";
import { stringEndsWith, stringStartsWith, stringReplace } from "./string";
/**
 * @hidden
 */
export let DescriptionSerializer = /*@__PURE__*/ (() => {
    class DescriptionSerializer extends Base {
        constructor() {
            super();
            this.g = false;
            this.f = false;
            this.e = false;
        }
        m(a, b) {
            let c = DescriptionTreeBuilder.createTree(a, b);
            let d = new DescriptionSerializerBuilder();
            this.n(a, c, d);
            return d.toString();
        }
        q(a, b, c) {
            this.n(a, b, c);
        }
        c(a, b) {
            let c = new JsonDictionaryParser();
            let d = c.parse(b);
            return this.d(a, d, false, false);
        }
        d(a, b, c, d) {
            if (!(typeCast(JsonDictionaryObject.$, b) !== null)) {
                throw new NotSupportedException(1, "expected an object at the root of the json");
            }
            let e = b;
            if (c) {
                this.f = true;
            }
            if (d) {
                this.e = true;
            }
            let f = this.b(a, e);
            this.f = false;
            this.e = false;
            return f;
        }
        b(a, b, c = 8) {
            if (!b.f("type")) {
                if (b.f("refType")) {
                    let d = new EmbeddedRefDescription();
                    d.refType = b.item("refType").value;
                    d.value = b.item("id").value;
                    let e = new DescriptionResult();
                    e.result = d;
                    return e;
                }
                else {
                    throw new NotSupportedException(1, "expected type to be defined for the json object");
                }
            }
            let f = new DescriptionResult();
            let g = b.item("type").value;
            let h = a.k(g);
            f.result = h;
            if (h == null) {
                if (this.g) {
                    throw new NotSupportedException(1, "missing description for type: " + g);
                }
                f.d("couldn't find registered description for type: " + g);
                return f;
            }
            let i = b.d();
            for (let j = 0; j < i.length; j++) {
                let k = i[j];
                let l = a.d(g, TypeDescriptionContext.n(k));
                if (l == null) {
                    if (TypeDescriptionContext.n(k) == "Name") {
                        let m = "string";
                        let n = b.item(k);
                        let o = this.h(f, a, n, m);
                        h.name = o;
                    }
                    continue;
                }
                let p = b.item(k);
                if (l.knownType == 14 || l.knownType == 11 || l.knownType == 12) {
                    let q = p;
                    switch (l.knownType) {
                        case 14:
                            q = this.j(a, p);
                            break;
                        case 12:
                            q = this.k(a, p);
                            break;
                        case 11:
                            q = this.i(a, p);
                            break;
                    }
                    if (!this.e) {
                        a.q(h, k, l, q);
                    }
                }
                else if (typeCast(JsonDictionaryObject.$, p) !== null) {
                    let r = p;
                    let s = this.b(a, r, l.knownType);
                    f.e(s);
                    a.q(h, k, l, s.result);
                }
                else if (typeCast(JsonDictionaryArray.$, p) !== null) {
                    let t = p;
                    let u = "string";
                    let v = false;
                    if (l.knownType == 10) {
                        u = l.specificExternalType;
                    }
                    if (l.knownType == 9) {
                        v = true;
                        u = l.collectionElementType;
                    }
                    let w = this.a(f, a, t, u);
                    if (!this.e || v) {
                        a.q(h, k, l, w);
                    }
                }
                else {
                    let x = l.specificExternalType;
                    if (x == null && l.knownType == 3) {
                        x = "DateTime";
                    }
                    if (x == null) {
                        x = "String";
                    }
                    let y = p;
                    let z = this.h(f, a, y, x);
                    if (this.f) {
                        if (stringEndsWith(l.propertyName, "MemberPath") || (g != null && stringEndsWith(g, "Axis") && l.propertyName.toLowerCase() == "label")) {
                            let aa = z.toString();
                            if (stringStartsWith(aa, "{")) {
                                if (!stringStartsWith(aa, "{[")) {
                                    aa = aa.substr(1, aa.length - 2);
                                    aa = "{[" + aa + "]}";
                                    z = aa;
                                }
                            }
                            else {
                                if (!stringStartsWith(aa, "[")) {
                                    aa = "[" + aa + "]";
                                    z = aa;
                                }
                            }
                        }
                    }
                    if (!this.e) {
                        a.q(h, k, l, z);
                    }
                }
            }
            return f;
        }
        i(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            if (b.f("x")) {
                c = b.item("x").value;
            }
            if (b.f("y")) {
                d = b.item("y").value;
            }
            return ((() => {
                let $ret = new PointDescription();
                $ret.x = c;
                $ret.y = d;
                return $ret;
            })());
        }
        k(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            if (b.f("width")) {
                c = b.item("width").value;
            }
            if (b.f("height")) {
                d = b.item("height").value;
            }
            return ((() => {
                let $ret = new SizeDescription();
                $ret.width = c;
                $ret.height = d;
                return $ret;
            })());
        }
        j(a, b) {
            if (b == null) {
                return null;
            }
            let c = NaN;
            let d = NaN;
            let e = NaN;
            let f = NaN;
            if (b.f("left")) {
                c = b.item("left").value;
            }
            if (b.f("top")) {
                d = b.item("top").value;
            }
            if (b.f("width")) {
                e = b.item("width").value;
            }
            if (b.f("height")) {
                f = b.item("height").value;
            }
            return ((() => {
                let $ret = new RectDescription();
                $ret.left = c;
                $ret.top = d;
                $ret.width = e;
                $ret.height = f;
                return $ret;
            })());
        }
        a(a, b, c, d) {
            let e = new Array(c.items.length);
            for (let f = 0; f < c.items.length; f++) {
                let g = c.items[f];
                if (typeCast(JsonDictionaryObject.$, g) !== null) {
                    let h = g;
                    let i = this.b(b, h);
                    a.e(i);
                    e[f] = i.result;
                }
                else if (typeCast(JsonDictionaryArray.$, g) !== null) {
                    let j = g;
                    let k = this.a(a, b, j, d);
                    e[f] = k;
                }
                else {
                    let l = g;
                    let m = this.h(a, b, l, d);
                    e[f] = m;
                }
            }
            return e;
        }
        h(a, b, c, d) {
            switch (c.d) {
                case 1: return c.value;
                case 3: return c.value;
                case 0: switch (d.toLowerCase()) {
                    case "int": return typeGetValue(c.value);
                    case "double": return c.value;
                    case "timespan": return c.value;
                    case "short": return typeGetValue(c.value);
                    case "long": return typeGetValue(c.value);
                    case "float": return c.value;
                    case "byte": return typeGetValue(c.value);
                    default:
                        a.d("unexpected target type for number: " + d);
                        return c.value;
                }
                case 2:
                    if (d.toLowerCase() == "datetime") {
                        let val_ = c.value;
                        let e = (new Date(val_));
                        return e;
                    }
                    return c.value;
                default:
                    a.d("unexpected value type");
                    return c.value;
            }
        }
        n(a, b, c) {
            c.f("{");
            c.i();
            c.f("\"type\": \"" + b.h + "\"");
            let d = b.e();
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e];
                if (e >= 0) {
                    c.f(",");
                }
                this.o(a, b, f, c);
            }
            c.h();
            c.f("}");
        }
        l(a) {
            if (a == null) {
                return null;
            }
            return a.substr(0, 1).toLowerCase() + a.substr(1);
        }
        o(a, b, c, d) {
            if (c.c.toLowerCase() == "type") {
                return;
            }
            d.e("\"" + this.l(c.c) + "\": ");
            this.r(a, b, c, c.b, d);
        }
        r(a, b, c, d, e) {
            let f = 2;
            if (c.a != null) {
                f = c.a.knownType;
            }
            switch (f) {
                case 6:
                case 16:
                case 10:
                    {
                        e.e("[");
                        let g = c.b;
                        let h = c.a.specificType;
                        if (c.a.knownType == 6 || c.a.knownType == 16) {
                            h = "String";
                        }
                        for (let i = 0; i < g.length; i++) {
                            if (i > 0) {
                                e.e(", ");
                            }
                            let j = h;
                            if (typeCast(DescriptionTreeNode.$, g[i]) !== null) {
                                this.n(a, g[i], e);
                            }
                            else {
                                this.p(a, h, g[i], e);
                            }
                        }
                        e.e("]");
                    }
                    break;
                case 7:
                    this.p(a, "Boolean", d, e);
                    break;
                case 9:
                    {
                        e.e("[");
                        let k = c.b;
                        let l = c.a.collectionElementType;
                        for (let m = 0; m < k.length; m++) {
                            if (m > 0) {
                                e.e(", ");
                            }
                            let n = l;
                            if (typeCast(DescriptionTreeNode.$, k[m]) !== null) {
                                this.n(a, k[m], e);
                            }
                            else {
                                this.p(a, l, k[m], e);
                            }
                        }
                        e.e("]");
                    }
                    break;
                case 4:
                case 18:
                case 19:
                case 20:
                case 5:
                case 2:
                    this.p(a, "String", d, e);
                    break;
                case 3:
                    this.p(a, "DateTime", d, e);
                    break;
                case 8:
                    if (c.a.specificExternalType.toLowerCase() == "string") {
                        this.p(a, "String", d, e);
                    }
                    else {
                        this.n(a, d, e);
                    }
                    break;
                case 1:
                    this.p(a, "Double", d, e);
                    break;
                case 14:
                case 12:
                case 11:
                    this.n(a, d, e);
                    break;
                case 21:
                    this.p(a, "TimeSpan", d, e);
                    break;
                case 17:
                case 0:
                case 15:
                case 13: throw new NotImplementedException(0);
            }
        }
        p(a, b, c, d) {
            switch (b.toLowerCase()) {
                case "string":
                    if (c == null) {
                        d.e("null");
                    }
                    else {
                        d.e("\"" + stringReplace(c, "\"", "\\\"") + "\"");
                    }
                    break;
                case "number":
                case "double":
                    d.e(c.toString());
                    break;
                case "int":
                    d.e(c.toString());
                    break;
                case "float":
                    d.e(c.toString());
                    break;
                case "long":
                    d.e(c.toString());
                    break;
                case "decimal":
                    d.e(c.toString());
                    break;
                case "timespan":
                    d.e(c.toString());
                    break;
                case "boolean":
                    d.e(c == null ? "false" : c.toString().toLowerCase());
                    break;
                case "datetime":
                    let v_ = c;
                    d.e("\"" + (v_.toJSON()) + "\"");
                    break;
            }
        }
    }
    DescriptionSerializer.$t = /*@__PURE__*/ markType(DescriptionSerializer, 'DescriptionSerializer');
    return DescriptionSerializer;
})();
//# sourceMappingURL=DescriptionSerializer.js.map
