/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { ComponentRenderer } from "./ComponentRenderer";
import { Base, fromEnum, markType, IList_$type, typeCast, Array_$type } from "./type";
import { CodeGeneratingRendererResult } from "./CodeGeneratingRendererResult";
import { WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter } from "./WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter";
import { WPFXamlCodeGeneratingComponentRendererCodeEmitter } from "./WPFXamlCodeGeneratingComponentRendererCodeEmitter";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { CodeGenerationTransformer } from "./CodeGenerationTransformer";
import { List$1 } from "./List$1";
import { CodeGenerationItemBuilder } from "./CodeGenerationItemBuilder";
import { IComponentRendererAdapter_$type } from "./IComponentRendererAdapter";
import { stringContains } from "./string";
/**
 * @hidden
 */
var CodeGeneratingComponentRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(CodeGeneratingComponentRenderer, _super);
    function CodeGeneratingComponentRenderer(a, b) {
        var _this = _super.call(this) || this;
        _this.cz = null;
        _this.c0 = 0;
        _this.cz = b;
        _this.c0 = a;
        ComponentRenderer.platform = _this.c1(a);
        _this.d = new CodeGenerationRendererAdapter(a, _this.d);
        _this.context = new TypeDescriptionContext(_this.d, ComponentRenderer.platform);
        _this.f = new CodeGenerationTransformer(a);
        return _this;
    }
    CodeGeneratingComponentRenderer.prototype.loadCodeJson = function (a) {
        this.loadJson(a, function (b) {
            return ((function () {
                var $ret = new CodeGenerationContainer();
                $ret.id = b;
                return $ret;
            })());
        });
    };
    CodeGeneratingComponentRenderer.prototype.cx = function (a, b) {
        switch (this.c0) {
            case 1: break;
            case 2: break;
            case 3: break;
            case 4: break;
            case 0: if (a.forceCodeBehind) {
                return new WPFCodeBehindCodeGeneratingComponentRendererCodeEmitter(a, b);
            }
            else {
                return new WPFXamlCodeGeneratingComponentRendererCodeEmitter(a, b);
            }
        }
        return null;
    };
    CodeGeneratingComponentRenderer.prototype.emitCode = function (a) {
        var e_1, _a;
        var b = new CodeGeneratingRendererResult();
        try {
            for (var _b = tslib_1.__values(fromEnum(this.at.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c;
                d.c(b, this, this.cz);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.c3(b, a);
        return b;
    };
    CodeGeneratingComponentRenderer.prototype.c3 = function (a, b) {
        b.execute(a);
    };
    CodeGeneratingComponentRenderer.prototype.c1 = function (a) {
        switch (a) {
            case 1: return 3;
            case 2: return 2;
            case 3: return 4;
            case 4: return 8;
            case 0: return 0;
        }
        return 0;
    };
    CodeGeneratingComponentRenderer.$t = markType(CodeGeneratingComponentRenderer, 'CodeGeneratingComponentRenderer', ComponentRenderer.$);
    return CodeGeneratingComponentRenderer;
}(ComponentRenderer));
export { CodeGeneratingComponentRenderer };
/**
 * @hidden
 */
var CodeGenerationContainer = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(CodeGenerationContainer, _super);
    function CodeGenerationContainer() {
        var _this = _super.call(this) || this;
        _this._id = null;
        _this.a = null;
        _this.a = new List$1(CodeGenerationItemBuilder.$, 0);
        return _this;
    }
    Object.defineProperty(CodeGenerationContainer.prototype, "id", {
        get: function () {
            return this._id;
        },
        set: function (a) {
            this._id = a;
        },
        enumerable: true,
        configurable: true
    });
    CodeGenerationContainer.prototype.c = function (a, b, c) {
        var e_2, _a;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                var e = b.cx(c, a);
                d.j(e);
                var f = e.toString();
                a.addContainerResult(this.id, f);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    CodeGenerationContainer.$t = markType(CodeGenerationContainer, 'CodeGenerationContainer');
    return CodeGenerationContainer;
}(Base));
export { CodeGenerationContainer };
/**
 * @hidden
 */
var CodeGenerationRendererAdapter = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(CodeGenerationRendererAdapter, _super);
    function CodeGenerationRendererAdapter(a, b) {
        var _this = _super.call(this) || this;
        _this.a = 0;
        _this.b = null;
        _this.b = b;
        _this.a = a;
        return _this;
    }
    CodeGenerationRendererAdapter.prototype.createColorCollection = function (a) {
        var b = new List$1(Base.$, 0);
        for (var c = 0; c < a.length; c++) {
            b.add1(a[c]);
        }
        return b;
    };
    CodeGenerationRendererAdapter.prototype.createBrushCollection = function (a) {
        var b = new List$1(Base.$, 0);
        for (var c = 0; c < a.length; c++) {
            b.add1(a[c]);
        }
        return b;
    };
    CodeGenerationRendererAdapter.prototype.createObject = function (a, b, c) {
        var d = new CodeGenerationItemBuilder(a, c, b);
        return d;
    };
    CodeGenerationRendererAdapter.prototype.coerceToEnum = function (a, b, c) {
        return c;
    };
    CodeGenerationRendererAdapter.prototype.onUIThread = function (a, b) {
        b();
    };
    CodeGenerationRendererAdapter.prototype.setOrUpdateCollectionOnTarget = function (a, b, c, d, e, f) {
        var g = this.getPropertyValue(e, b);
        if (g == null) {
            var h = new List$1(Base.$, 0);
            var i = f;
            for (var j = 0; j < i.count; j++) {
                h.add1(i.item(j));
            }
            this.setPropertyValue(e, b, c, h, null, null);
        }
        else {
            var k = f;
            var l = g;
            l.clear();
            for (var m = 0; m < k.count; m++) {
                l.add(k.item(m));
            }
        }
    };
    CodeGenerationRendererAdapter.prototype.c = function (a) {
        if (a == null) {
            return false;
        }
        return false;
    };
    CodeGenerationRendererAdapter.prototype.onPendingRef = function (a, b, c, d) {
        var e = a;
        e.k(b, c, d);
    };
    CodeGenerationRendererAdapter.prototype.setPropertyValue = function (a, b, c, d, e, f) {
        if (!(typeCast(CodeGenerationItemBuilder.$, a) !== null)) {
            this.b.setPropertyValue(a, b, c, d, e, f);
            return;
        }
        while (stringContains(b, ".")) {
            var g = b.split('.');
            var h = this.getPropertyValue(a, g[0]);
            if (h != null && !this.c(h)) {
                b = "";
                for (var i = 1; i < g.length; i++) {
                    if (i > 1) {
                        b += ".";
                    }
                    b += g[i];
                }
                a = h;
            }
            else {
                var j = a;
                var k = j.a(g[0]);
                h = k;
                this.setPropertyValue(a, g[0], c, h, null, f);
                b = "";
                for (var l = 1; l < g.length; l++) {
                    if (l > 1) {
                        b += ".";
                    }
                    b += g[l];
                }
                a = h;
            }
        }
        var m = a;
        m.m(b, c, d, f);
    };
    CodeGenerationRendererAdapter.prototype.getPropertyValue = function (a, b) {
        while (stringContains(b, ".")) {
            var c = b.split('.');
            var d = this.getPropertyValue(a, c[0]);
            if (d != null) {
                b = "";
                for (var e = 1; e < c.length; e++) {
                    if (e > 1) {
                        b += ".";
                    }
                    b += c[e];
                }
                a = d;
            }
            else {
                var f = a;
                var g = f.a(c[0]);
                d = g;
                for (var h = 1; h < c.length; h++) {
                    if (h > 1) {
                        b += ".";
                    }
                    b += c[h];
                }
                a = d;
            }
        }
        var i = a;
        return i.f(b);
    };
    CodeGenerationRendererAdapter.prototype.getRootObject = function (a) {
        var b = a;
        var c = b.a.count > 0 ? b.a._inner[0] : null;
        return c;
    };
    CodeGenerationRendererAdapter.prototype.clearContainer = function (a, b, c) {
        var d = a;
        var e = d.a.count > 0 ? d.a._inner[0] : null;
        d.a.clear();
        c(false);
    };
    CodeGenerationRendererAdapter.prototype.forPropertyValueItem = function (a, b, c) {
        var d = this.getPropertyValue(a, b);
        if (typeCast(IList_$type, d) !== null) {
            var e = d;
            for (var f = 0; f < e.count; f++) {
                c(e.item(f));
            }
        }
        else if (typeCast(Array_$type, d) !== null) {
            var g = d;
            for (var h = 0; h < g.length; h++) {
                c(g[h]);
            }
        }
    };
    CodeGenerationRendererAdapter.prototype.clearCollection = function (a, b, c) {
        var d = this.getPropertyValue(a, b);
        if (typeCast(IList_$type, d) !== null) {
            d.clear();
        }
        else if (typeCast(Array_$type, d) !== null) {
            this.setPropertyValue(a, b, c, null, d, null);
        }
    };
    CodeGenerationRendererAdapter.prototype.addItemToCollection = function (a, b, c, d, e) {
        var f = this.getPropertyValue(c, a);
        if (typeCast(IList_$type, f) !== null) {
            f.insert(d, e);
        }
        else if (typeCast(Array_$type, f) !== null) {
            var g = f;
            var h = new List$1(Base.$, 0);
            for (var i = 0; i < g.count; i++) {
                h.add1(g.item(i));
            }
            h.insert1(d, e);
            var j = [g.count + 1];
            for (var k = 0; k < j.length; k++) {
                j[k] = h._inner[k];
            }
            this.setPropertyValue(c, a, b, j, f, null);
        }
    };
    CodeGenerationRendererAdapter.prototype.resetPropertyOnTarget = function (a, b, c, d) {
        while (stringContains(b, ".")) {
            var e = b.split('.');
            var f = this.getPropertyValue(d, e[0]);
            if (f != null && !this.c(f)) {
                b = "";
                for (var g = 1; g < e.length; g++) {
                    if (g > 1) {
                        b += ".";
                    }
                    b += e[g];
                }
                d = f;
            }
            else {
                var h = d;
                var i = h.a(e[0]);
                f = i;
                this.setPropertyValue(d, e[0], c, f, null, null);
                b = "";
                for (var j = 1; j < e.length; j++) {
                    if (j > 1) {
                        b += ".";
                    }
                    b += e[j];
                }
                d = f;
            }
        }
        var k = d;
        k.l(b, c);
    };
    CodeGenerationRendererAdapter.prototype.replaceItemInCollection = function (a, b, c, d, e) {
        var f = this.getPropertyValue(c, a);
        if (typeCast(IList_$type, f) !== null) {
            f.item(d, e);
        }
        else if (typeCast(Array_$type, f) !== null) {
            var g = f;
            var h = new List$1(Base.$, 0);
            for (var i = 0; i < g.count; i++) {
                h.add1(g.item(i));
            }
            h._inner[d] = e;
            var j = [g.count + 1];
            for (var k = 0; k < j.length; k++) {
                j[k] = h._inner[k];
            }
            this.setPropertyValue(c, a, b, j, f, null);
        }
    };
    CodeGenerationRendererAdapter.prototype.replaceRootItem = function (a, b, c, d) {
        var e = this.createObject(b, a, c);
        var f = a;
        var g = f.a.count > 0 ? f.a._inner[0] : null;
        f.a.clear();
        {
            f.a.add(e);
        }
        d(false);
    };
    CodeGenerationRendererAdapter.prototype.removeItemFromCollection = function (a, b, c, d) {
        var e = this.getPropertyValue(c, a);
        if (typeCast(IList_$type, e) !== null) {
            e.removeAt(d);
        }
        else if (typeCast(Array_$type, e) !== null) {
            var f = e;
            var g = new List$1(Base.$, 0);
            for (var h = 0; h < f.count; h++) {
                g.add1(f.item(h));
            }
            g.removeAt(d);
            var i = [f.count - 1];
            for (var j = 0; j < i.length; j++) {
                i[j] = g._inner[j];
            }
            this.setPropertyValue(c, a, b, i, e, null);
        }
    };
    CodeGenerationRendererAdapter.prototype.removeRootItem = function (a, b, c) {
        var d = a;
        var e = d.a.count > 0 ? d.a._inner[0] : null;
        d.a.clear();
        c(false);
    };
    CodeGenerationRendererAdapter.prototype.flushChanges = function (a) {
    };
    CodeGenerationRendererAdapter.$t = markType(CodeGenerationRendererAdapter, 'CodeGenerationRendererAdapter', Base.$, [IComponentRendererAdapter_$type]);
    return CodeGenerationRendererAdapter;
}(Base));
export { CodeGenerationRendererAdapter };
//# sourceMappingURL=CodeGeneratingComponentRenderer_combined.js.map
