import { ComponentRenderer } from "./ComponentRenderer";
import { Base, Type } from "./type";
import { CodeGeneratingComponentRendererCodeEmitter } from "./CodeGeneratingComponentRendererCodeEmitter";
import { CodeGenerationRendererOptions } from "./CodeGenerationRendererOptions";
import { CodeGeneratingRendererResult } from "./CodeGeneratingRendererResult";
import { CodeGenerationTargetPlatforms } from "./CodeGenerationTargetPlatforms";
import { ICodeGenerationRendererTemplate } from "./ICodeGenerationRendererTemplate";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { List$1 } from "./List$1";
import { CodeGenerationItemBuilder } from "./CodeGenerationItemBuilder";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
import { TypeDescriptionMetadata } from "./TypeDescriptionMetadata";
import { DescriptionRef } from "./DescriptionRef";
/**
 * @hidden
 */
export declare class CodeGeneratingComponentRenderer extends ComponentRenderer {
    static $t: Type;
    loadCodeJson(a: string): void;
    cx(a: CodeGenerationRendererOptions, b: CodeGeneratingRendererResult): CodeGeneratingComponentRendererCodeEmitter;
    emitCode(a: ICodeGenerationRendererTemplate): CodeGeneratingRendererResult;
    private c3;
    private cz;
    private c0;
    constructor(a: CodeGenerationTargetPlatforms, b: CodeGenerationRendererOptions);
    private c1;
}
/**
 * @hidden
 */
export declare class CodeGenerationContainer extends Base {
    static $t: Type;
    private _id;
    id: string;
    constructor();
    a: List$1<CodeGenerationItemBuilder>;
    c(a: CodeGeneratingRendererResult, b: CodeGeneratingComponentRenderer, c: CodeGenerationRendererOptions): void;
}
/**
 * @hidden
 */
export declare class CodeGenerationRendererAdapter extends Base implements IComponentRendererAdapter {
    static $t: Type;
    private a;
    private b;
    constructor(a: CodeGenerationTargetPlatforms, b: IComponentRendererAdapter);
    createColorCollection(a: any[]): any;
    createBrushCollection(a: any[]): any;
    createObject(a: string, b: any, c: TypeDescriptionContext): any;
    coerceToEnum(a: string, b: TypeDescriptionContext, c: string): any;
    onUIThread(a: any, b: () => void): void;
    setOrUpdateCollectionOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: TypeDescriptionContext, e: any, f: any): void;
    private c;
    onPendingRef(a: any, b: string, c: TypeDescriptionMetadata, d: DescriptionRef): void;
    setPropertyValue(a: any, b: string, c: TypeDescriptionMetadata, d: any, e: any, f: DescriptionRef): void;
    getPropertyValue(a: any, b: string): any;
    getRootObject(a: any): any;
    clearContainer(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    forPropertyValueItem(a: any, b: string, c: (arg1: any) => void): void;
    clearCollection(a: any, b: string, c: TypeDescriptionMetadata): void;
    addItemToCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    resetPropertyOnTarget(a: any, b: string, c: TypeDescriptionMetadata, d: any): void;
    replaceItemInCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number, e: any): void;
    replaceRootItem(a: any, b: string, c: TypeDescriptionContext, d: (arg1: boolean) => void): void;
    removeItemFromCollection(a: string, b: TypeDescriptionMetadata, c: any, d: number): void;
    removeRootItem(a: any, b: TypeDescriptionContext, c: (arg1: boolean) => void): void;
    flushChanges(a: any): void;
}
