import { Base, Type } from "./type";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { ITypeDescriptionPropertyTransforms } from "./ITypeDescriptionPropertyTransforms";
import { TypeDescriptionCleanups } from "./TypeDescriptionCleanups";
import { Dictionary$2 } from "./Dictionary$2";
import { Description } from "./Description";
import { DescriptionTreeNode } from "./DescriptionTreeNode";
import { DescriptionRef } from "./DescriptionRef";
import { TypeDescriptionPlatform } from "./TypeDescriptionPlatform";
/**
 * @hidden
 */
export declare class ComponentRenderer extends Base {
    static $t: Type;
    d: IComponentRendererAdapter;
    private _context;
    context: TypeDescriptionContext;
    private _isProceedOnErrorEnabled;
    isProceedOnErrorEnabled: boolean;
    f: ITypeDescriptionPropertyTransforms;
    g: TypeDescriptionCleanups;
    static platform: TypeDescriptionPlatform;
    constructor();
    private e;
    toJson(a: (arg1: any) => string): string;
    private cs;
    private ct;
    private s;
    private q;
    private cr;
    private k;
    createObjectFromJson(a: string, b: any): any;
    loadJson(a: string, b: (arg1: string) => any): void;
    loadJsonOverlay(a: string, b: (arg1: string) => any, c: (arg1: string) => any): void;
    loadJsonDelta(a: string, b: (arg1: string) => any, c: boolean): void;
    private b8;
    private bq;
    private b4;
    private b5;
    private bt;
    private br;
    private a;
    private be;
    private ak;
    private al;
    private am;
    private aj;
    private ai;
    private ap;
    readonly at: Dictionary$2<any, ContainerState>;
    private an;
    private ah;
    private ao;
    private aq;
    private as;
    cleanup(a: any, b: boolean): void;
    render(a: Description, b: any): void;
    private co;
    private ca;
    private cm;
    provideRefValue(a: any, b: string, c: any): void;
    removeRefValue(a: any, b: string): void;
    private ck;
    clearRefValues(a: any): void;
    private cn;
    private cq;
    private cw;
    private b3;
    private cb;
    private cc;
    private u;
    private aa;
    private ag;
    private ae;
    private bh;
    private bd;
    private bc;
    private bb;
    private ba;
    private a9;
    private a8;
    private a7;
    b(a: string, b: ContainerState): DescriptionRef;
    private bn;
    private a6;
    private bm;
    private a4;
    private bl;
    private bp;
    private a3;
    private a2;
    private a1;
    private bo;
    private a0;
    private az;
    private ar;
    addPropertyUpdatingListener(a: string, b: (propertyName: string, target: any, newValue: any) => void): void;
    private au;
    addReferenceLookupListener(a: (container: any, refType: string, id: string) => any): void;
    removePropertyUpdatingListener(a: string, b: (propertyName: string, target: any, newValue: any) => void): void;
    private av;
    addNamespaceLookupListener(a: (container: any) => string): void;
    removeNamespaceLookupListener(a: (container: any) => string): void;
    private ay;
    private cu;
    hasUserRef(a: string): boolean;
    private _shouldNamespaceSystemRefValues;
    shouldNamespaceSystemRefValues: boolean;
    ce(a: any, b: string, c: any, d: boolean): void;
    removeRefValueCore(a: any, b: string, c: boolean): void;
    clearUserRefValues(): void;
    o(a: DescriptionRef): boolean;
    bj(a: DescriptionRef): any;
    n(a: string): boolean;
    c(a: string): DescriptionRef;
    private bk;
    private z;
    private ad;
    private y;
    private cp;
    private ac;
    b2(a: any, b: any, c: ContainerState): void;
    private ax;
    private x;
    private cf;
    private ab;
    private w;
    private j;
    private bu;
    private bf;
    private r;
    private a5;
    private aw;
    private v;
    private bz;
    private cv;
    private bi;
    private m;
    private l;
}
/**
 * @hidden
 */
export declare class ContainerState extends Base {
    static $t: Type;
    i: any;
    private e;
    private f;
    private d;
    private g;
    private c;
    k(a: any, b: number, c: any, d: DescriptionTreeNode, e: (arg1: any, arg2: string, arg3: any, arg4: boolean) => void, f: number): void;
    a(a: number): boolean;
    b(a: any): boolean;
    j(a: number): any;
    l(a: ComponentRenderer, b: any, c: number, d: (arg1: any, arg2: string, arg3: boolean) => void): void;
    h(a: any): number;
}
